import os
import sys
import pathlib
from PIL import Image
 
# 获取当前dir下文件名符合pattern的files
# R为True  搜索子目录
def getAllFile(dir, pattern,R=False):
    d = pathlib.Path(dir)
    if R:
        files = d.rglob(pattern)
        files = [str(i) for i in files]
    else:
        files = d.glob(pattern)
        files = [os.path.realpath(i) for i in files]
    return files
 
def toBMP(file,n,gray=True):
    pageNum = int(n)
    if pageNum == 1:
        # 图片目录
        dir = os.path.split(os.path.realpath(file))[0]
        # 图片名称
        file_simple =  os.path.split(os.path.realpath(file))[1]
        # bmp文件在同一目录下  图片名称一样
        target= dir+os.path.sep +file_simple.split(".")[0] + ".bmp"
        # bmp已经存在  跳过
        if os.path.exists(target):
            print("{} is already exists".format(target))
            return
        # 使用PIL的image读取
        img = Image.open(file)
        # 修改图片size
        new_img = img.resize( img.size)
    
        if gray:
            target = dir + os.path.sep + file_simple.split(".")[0] + "_gray.bmp"
            if os.path.exists(target):
                print("{} is already exists".format(target))
                return
            #  转成黑白
            #new_img = new_img.convert('1')
        # 保存为bmp格式
        new_img.save( target, 'bmp')
        # cv2.imwrite(target,img)
        print("{} is ok".format(file))
        os.remove(file)

    if pageNum > 1:
        for i in range(pageNum):
            # 图片目录
            dir = os.path.split(os.path.realpath(file))[0]
            print(dir)
            # 图片名称
            file_simple =  os.path.split(os.path.realpath(file))[1]
            print(file_simple)
            # bmp文件在同一目录下  图片名称一样
            target= dir+os.path.sep +file_simple.split(".")[0] +"-" + str(i+1) + ".bmp"
            print(target)
            # bmp已经存在  跳过
            if os.path.exists(target):
                print("{} is already exists".format(target))
                return
            # 使用PIL的image读取
            newfile=dir+os.path.sep +file_simple.split(".")[0] +"-" + str(i+1) + ".png"
            print(newfile)
            img = Image.open(newfile)
            # 修改图片size
            new_img = img.resize( img.size)
        
            if gray:
                target = dir + os.path.sep + file_simple.split(".")[0] +"-" + str(i+1) + "_gray.bmp"
                print(target)
                if os.path.exists(target):
                    print("{} is already exists".format(target))
                    return
                #  转成黑白
                #new_img = new_img.convert('1')
            # 保存为bmp格式
            new_img.save( target, 'bmp')
            # cv2.imwrite(target,img)
            print("{} is ok".format(newfile))
            os.remove(newfile)

def toTIFF  (file,n,gray=True):
    pageNum = int(n)
    if pageNum == 1:
        # 图片目录
        dir = os.path.split(os.path.realpath(file))[0]
        # 图片名称
        file_simple =  os.path.split(os.path.realpath(file))[1]
        # bmp文件在同一目录下  图片名称一样
        target= dir+os.path.sep +file_simple.split(".")[0] + ".tif"
        # bmp已经存在  跳过
        if os.path.exists(target):
            print("{} is already exists".format(target))
            return
    
        # 使用PIL的image读取
        img = Image.open(file)
        # 修改图片size
        new_img = img.resize( img.size)
        new_img.save( target, 'tiff')
        # cv2.imwrite(target,img)
        print("{} is ok".format(file))
        os.remove(file)

    if pageNum > 1:
            for i in range(pageNum):
                # 图片目录
                dir = os.path.split(os.path.realpath(file))[0]
                print(dir)
                # 图片名称
                file_simple =  os.path.split(os.path.realpath(file))[1]
                print(file_simple)
                # bmp文件在同一目录下  图片名称一样
                target= dir+os.path.sep +file_simple.split(".")[0] +"-" + str(i+1) + ".tif"
                print(target)
                # bmp已经存在  跳过
                if os.path.exists(target):
                    print("{} is already exists".format(target))
                    return
                # 使用PIL的image读取
                newfile=dir+os.path.sep +file_simple.split(".")[0] +"-" + str(i+1) + ".png"
                print(newfile)
                img = Image.open(newfile)
                # 修改图片size
                new_img = img.resize( img.size)
                new_img.save( target, 'tiff')
                print("{} is ok".format(newfile))
                os.remove(newfile)



if __name__ == '__main__':
    # files = getAllFile("./my","*.png",False)
    # for file in files:
    #     toBMP(file,False)

    png_name = sys.argv[2].split(".")[0]+".png"
    extension = sys.argv[2].split(".")[1]

    if "tif" in extension :
        file = sys.argv[1]+"/"+png_name
        toTIFF(file,sys.argv[3],False)

    if "bmp" in extension :
        file = sys.argv[1]+"/"+png_name
        toBMP(file,sys.argv[3],False)
